// Copyright 2015-2017 Parity Technologies (UK) Ltd.
// This file is part of Parity.

// Parity is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// Parity is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with Parity.  If not, see <http://www.gnu.org/licenses/>.

import { handleActions } from 'redux-actions';

const initialState = {
  author: 'loading...',
  extraData: 'loading...',
  defaultExtraData: '0x01',
  minGasPrice: 'loading...',
  gasFloorTarget: 'loading...'
};

export const actionHandlers = {

  'update author' (state, action) {
    return {
      ...state,
      author: `${action.payload}`
    };
  },

  'update minGasPrice' (state, action) {
    return {
      ...state,
      minGasPrice: `${action.payload}`
    };
  },

  'update gasFloorTarget' (state, action) {
    return {
      ...state,
      gasFloorTarget: `${action.payload}`
    };
  },

  'update extraData' (state, action) {
    return {
      ...state,
      extraData: `${action.payload}`
    };
  },

  'update defaultExtraData' (state, action) {
    return {
      ...state,
      defaultExtraData: `${action.payload}`
    };
  }

};

export default handleActions(actionHandlers, initialState);
